class listComprehension {
    constructor(input, list) {
        const err = this._init(input, list);
        if (err) return err;
        return this._run()
    }

    _init(input, list) {
        this.input = input.split('for');
        this.expression = this._getExpression(this.input);
        this.forLoop = this._getForLoop(this.input);
        this.ifCondition = this._getIfCondition(this.input);
        this.placeHolder = this._getPlaceHolder(this.forLoop);
        this.list = this._getInitialList(this.forLoop, list, this.ifCondition);
    }

    _getExpression(input) {
        if (input && input.length) {
            return input[0].replace('[', '');
        } else {
            throw Error('No such expression')
        }
    }

    _getForLoop(input) {
        if (input && input.length === 2) {
            return input[1].split('in');
        } else {
            throw Error('No such for loop');
        }
    }

    _getIfCondition(input) {
        if (input && input.length === 2) {
            const splittedWithIf = input[1].split('if');
            if (splittedWithIf && splittedWithIf.length === 2){
                return splittedWithIf[1].replace(']', '');
            }
        }
        return null;
    }

    _getPlaceHolder(forLoop) {
        if (forLoop && forLoop.length) {
            return forLoop[0];
        } else {
            throw Error('No such variable in loop');
        }
    }

    _getInitialList(forLoop, list, condition) {
        if (list) {
            return list
        } else if (forLoop && forLoop.length === 2 && !condition) {
            return eval(forLoop[1].slice(0, -1));
        } else if (forLoop && forLoop.length === 2 && condition) {
            return eval(forLoop[1].split('if')[0].slice(0, -1));
        } else {
            throw Error('No initial list');
        }
    }

    _run() {
        const results = [];
        for (const element of this.list) {
            const evaluatedElement = this._evaluateExpression(element);
            if (this.ifCondition) {
                const evaluatedCondition = this._evaluateCondition(element);
                if (evaluatedCondition) {
                    results.push(evaluatedElement);
                }
            } else {
                results.push(evaluatedElement);
            }
        }
        return results;
    }

    _evaluateExpression(element) {
        const func = eval(`(${this.placeHolder}) => ${this.expression}`);
        return func(element);
    }
    _evaluateCondition(element) {
        const func = eval(`(${this.placeHolder}) => ${this.ifCondition}`);
        return func(element);
    }
}

module.exports = listComprehension;

